package com.jkcredit.invoice.credit.custInterface;

import com.alibaba.fastjson.JSONObject;
import com.jkcredit.invoice.common.DataResult;
import com.jkcredit.invoice.common.ResponseCode;
import com.jkcredit.invoice.model.entity.customer.CustomerRec;
import com.jkcredit.invoice.service.customer.CustomerService;
import com.jkcredit.invoice.service.lowerService.CustomeLowerService;
import com.jkcredit.invoice.util.RespR;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;


@Slf4j
@Service("customerInterLowerService")
public class CustomerInterLowerServiceImpl implements CustomerInterLowerService {

    @Autowired
    CustomeLowerService lowerService;

    @Autowired
    CustomerService customerService;


    /**
     * 无车 自有车 企业注册
     * @param appKey
     * @param api
     * @param data
     * @return
     */
    @Override
    public DataResult customeInterRec(String appKey, String api, String data,String requestid) {
        long costtimestart = System.currentTimeMillis();

        DataResult result = new DataResult();
        result.setData(3);
        result.setCode(200);
        result.setRequestid(requestid);
        result.setMsg("无法认证");

        try {
            log.info("[-CustomerInterLowerServiceImpl.customeInterRec-] request appKey=" + appKey + " ,api=" + api + " ,data=" +data);
            JSONObject jsonObject = JSONObject.parseObject(data);

            Integer interType =  0;//0-接口 1-平台 3.手工录入

            String  name = jsonObject.getString("name");//公司名称 companyName
            String  taxpayerCode = jsonObject.getString("taxpayerCode");//企业税号 companyReferencenum
            String  customerName = appKey;//客户名称

            /**
             * 所属类型：
             *1-行业用户  2-自营平台 3-合作商户
             */
            Integer  companyType = jsonObject.getInteger("companyType");
            /**
             * 运用类型:
             * 1-快递
             2-速运
             3-货运代理
             4-普通货运
             5-专线运输
             6-其他
             * 运营范围
             */
            Integer  operatingRangeType = jsonObject.getInteger("operatingRangeType");
            String  emergencyContact = jsonObject.getString("emergencyContact");//紧急联系人  companyLeader
            String  emergencyTel = jsonObject.getString("emergencyTel");//紧急联系人电话 companyLeaderPhone

            String  companyOpenbank = jsonObject.getString("companyOpenbank");//公司开户行
            String  companyOpenbankAcc = jsonObject.getString("companyOpenbankAcc");//公司开户行电话
            String  companyAdress = jsonObject.getString("companyAdress");//公司地址
            String  companyPhone = jsonObject.getString("companyPhone");//公司电话
            String  bussinessType = jsonObject.getString("bussinessType");//业务类型 0 -自有车 1-外协车 2-无车



            String  serviceStartTime = jsonObject.getString("serviceStartTime");//服务开始时间
            String  serviceEndTime = jsonObject.getString("serviceEndTime");//服务结束时间
            Integer  serviceType = jsonObject.getInteger("serviceType");//协议类型
            String  contractFileName = jsonObject.getString("contractFileName");//协议文件名
            String  base64Str = jsonObject.getString("base64Str");//协议base64编码



            if(StringUtils.isEmpty(data)|| null == jsonObject
                    || StringUtils.isEmpty(name)
                    || StringUtils.isEmpty(taxpayerCode)
                    || StringUtils.isEmpty(customerName)
                    || null == companyType
                    || null == operatingRangeType
                    || StringUtils.isEmpty(emergencyContact)
                    || StringUtils.isEmpty(emergencyTel)
                    || StringUtils.isEmpty(companyOpenbank)
                    || StringUtils.isEmpty(companyOpenbankAcc)
                    || StringUtils.isEmpty(companyAdress)
                    || StringUtils.isEmpty(companyPhone)
                    || StringUtils.isEmpty(bussinessType)
                    || StringUtils.isEmpty(serviceStartTime)
                    || StringUtils.isEmpty(serviceEndTime)
                    || null == serviceType
                    || StringUtils.isEmpty(contractFileName)
                    || StringUtils.isEmpty(base64Str)
                    ){
                return  result;
            }

            CustomerRec customerRec = new CustomerRec();
            customerRec.setCustomerName(customerName);//客户名称
            customerRec.setCompanyLeader(emergencyContact);//紧急联系人
            customerRec.setCompanyLeaderPhone(emergencyTel);//紧急联系人电话
            customerRec.setCompanyName(name);//企业名称
            customerRec.setCompanyReferencenum(taxpayerCode);//企业税号
            customerRec.setCompanyOpenbank(companyOpenbank);//公司开户行
            customerRec.setCompanyOpenbankAcc(companyOpenbankAcc);//公司开户行电话
            customerRec.setCompanyAdress(companyAdress);//公司地址
            customerRec.setCompanyPhone(companyPhone);//公司电话
            customerRec.setInterType(interType);////0-接口 1-平台 3.手工录入
            customerRec.setBussinessType(bussinessType);//业务类型 0 -自有车 1-外协车 2-无车
            customerRec.setOperatingRangeType(operatingRangeType);//运用类型
            customerRec.setCompanyType(companyType);//所属类型
            customerRec.setServiceStartTime(serviceStartTime);//服务开始时间
            customerRec.setServiceEndTime(serviceEndTime);//服务结束时间
            customerRec.setServiceType(serviceType);//协议类型
            customerRec.setContractFileName(contractFileName);//协议名称
            customerRec.setBase64Str(base64Str);//协议base64编码

            List<CustomerRec> customerRecs = new ArrayList<CustomerRec>();
            customerRecs.add(customerRec);
            RespR rs = lowerService.customeRec(customerRecs);
            long costtimeend = System.currentTimeMillis();
            log.info("[-CustomerInterLowerServiceImpl.customeInterRec-] result is "
                    + rs.toString() + ", request is " + data + " ,costtime="
                    + (costtimeend - costtimestart));
            if(null != rs && rs.getCode() == 0){
                result.setData(1);
                result.setCode(200);
                result.setMsg(rs.getMsg());
                return result;
            } else {
                result.setData(3);
                result.setCode(200);
                result.setMsg("无法认证");
                return result;
            }
        } catch (Exception e) {
            log.error("[-CustomerInterLowerServiceImpl.customeInterRec-] get httpclient exception is "
                    + e + ", request is " + data);
        }
        return result;
    }

    /**
     * 无车 自有车企业查询
     * @param appKey
     * @param api
     * @param data
     * @return
     */
    @Override
    public DataResult customeInterRecQuery(String appKey, String api, String data,String requestid) {

        long costtimestart = System.currentTimeMillis();

        DataResult result = new DataResult();

        result.setData(3);
        result.setCode(200);
        result.setRequestid(requestid);
        result.setMsg("无法认证");

        try {
        log.info("[-CustomerInterLowerServiceImpl.customeInterRecQuery-] request appKey=" + appKey + " ,api=" + api + " ,data=" +data);
        JSONObject jsonObject = JSONObject.parseObject(data);
        String companyName =  jsonObject.getString("companyName");//企业名称
        String taxpayerCode = jsonObject.getString("taxpayerCode");//企业税号
        if(StringUtils.isEmpty(data)|| null == jsonObject || StringUtils.isEmpty(companyName) || StringUtils.isEmpty(taxpayerCode)){
            return  result;
        }


        CustomerRec customerRec = new CustomerRec();
        customerRec.setCompanyName(companyName);
        customerRec.setCompanyReferencenum(taxpayerCode);
        RespR rs = customerService.customerRecQuery(customerRec);
        long costtimeend = System.currentTimeMillis();
        log.info("[-CustomerInterLowerServiceImpl.customeInterRecQuery-] result is "
                    + rs.toString() + ", request is " + data + " ,costtime="
                    + (costtimeend - costtimestart));
        if(null != rs && rs.getCode() == 0){
           result.setData(1);
           result.setCode(200);
           result.setMsg(rs.getData().toString());
           return result;
        } else {
            result.setData(3);
            result.setCode(200);
            result.setMsg("无法认证");
            return result;
        }
        } catch (Exception e) {
            log.error("[-CustomerInterLowerServiceImpl.customeInterRecQuery-] get httpclient exception is "
                            + e + ", request is " + data);
        }
        return result;
    }
}
