package com.jkcredit.invoice.service.nocar.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jkcredit.invoice.mapper.customer.CustomerCarRecMapper;
import com.jkcredit.invoice.mapper.customer.CustomerRecMapper;
import com.jkcredit.invoice.mapper.waybill.NoCarWaybillMapper;
import com.jkcredit.invoice.model.entity.customer.CustomerCarRec;
import com.jkcredit.invoice.model.entity.customer.CustomerRec;
import com.jkcredit.invoice.model.entity.user.User;
import com.jkcredit.invoice.model.entity.waybill.NoCarWayBill;
import com.jkcredit.invoice.service.customer.CustomerOperService;
import com.jkcredit.invoice.service.lowerService.NoCarService;
import com.jkcredit.invoice.service.nocar.NoCarBillWayService;
import com.jkcredit.invoice.util.DateUtil;
import com.jkcredit.invoice.util.RespR;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;
@Service
public class NoCarBillWayServiceImpl extends ServiceImpl<NoCarWaybillMapper,NoCarWayBill> implements NoCarBillWayService{
    @Autowired
    NoCarWaybillMapper noCarWaybillMapper;

    @Autowired
    CustomerCarRecMapper customerCarRecMapper;

    @Autowired
    NoCarService noCarService;

    @Autowired
    CustomerRecMapper customerRecMapper;

    @Autowired
    CustomerOperService customerOperService;
    @Override
    public IPage<List<NoCarWayBill>> findByPageAndWayBill(Page page, NoCarWayBill noCarWayBill) {
        return noCarWaybillMapper.selectAllByPage(page,noCarWayBill);
    }

    @Override
    public IPage<List<NoCarWayBill>> findByPageAndWayBillException(Page page, NoCarWayBill noCarWayBill) {
        return noCarWaybillMapper.selectAllByPageException(page,noCarWayBill);
    }
    @Override
    public RespR batchBillWayStart(List<NoCarWayBill> noCarWayBills,String customerName) {
        StringBuffer stringBuffer = new StringBuffer();
        //保存批次号信息
        String batchNumber = customerOperService.saveCustomerOper(customerName,1);
        noCarWayBills.parallelStream().forEach(noCarWayBill -> {
            //根据税号，查询备案企业
            CustomerRec customerRec = new CustomerRec();
            customerRec.setCustomerName(customerName);
            customerRec.setCompanyReferencenum(noCarWayBill.getTaxplayerCode());
            customerRec = customerRecMapper.selectByCustomerNameAndCompanyReference(customerRec);
            if(customerRec == null){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append("企业税号未备案#");
                return;
            }
            noCarWayBill.setCompanyName(customerRec.getCompanyName());
            noCarWayBill.setCustomerName(customerName);
            noCarWayBill.setBatchNum(batchNumber);
            //1.查询是否有车辆备案
            CustomerCarRec customerCarRec = customerCarRecMapper.selectByCarNum(noCarWayBill.getPlateColor());

            //2.无车车辆备案时进行车辆备案
            if(customerCarRec== null || customerCarRec.getRecStatus()!=1){
                List<CustomerCarRec> customerCarRecs = new ArrayList<>();
                customerCarRec = new CustomerCarRec();
                customerCarRec.setCompanyName(noCarWayBill.getCompanyName());
                customerCarRec.setCarNum(noCarWayBill.getPlateNum());
                customerCarRec.setCarColor(noCarWayBill.getPlateColor());
                customerCarRec.setCustomerName(customerName);
                customerCarRec.setBusinessType("2");
                customerCarRecs.add(customerCarRec);
                RespR respR = noCarService.customerCarRec(customerCarRecs);
                if(respR.getCode() ==1){
                    stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
                    return;
                }
            }

            //3.进行上传
            RespR respR = noCarService.noCarWaybillStart(noCarWayBill);
            if (respR.getCode() == 1){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
            }
        });
        if(!StringUtils.isEmpty(stringBuffer.toString())){
            return new RespR(false,stringBuffer.toString());
        }
        return new RespR(Boolean.TRUE);
    }

    @Override
    public RespR batchHsitoryBillWay(List<NoCarWayBill> noCarWayBills, String customerName){
        StringBuffer stringBuffer = new StringBuffer();
        //保存批次号信息
        String batchNumber = customerOperService.saveCustomerOper(customerName,3);
        noCarWayBills.parallelStream().forEach(noCarWayBill -> {
            //根据税号，查询备案企业
            CustomerRec customerRec = new CustomerRec();
            customerRec.setCustomerName(customerName);
            customerRec.setCompanyReferencenum(noCarWayBill.getTaxplayerCode());
            customerRec = customerRecMapper.selectByCustomerNameAndCompanyReference(customerRec);
            if(customerRec == null || customerRec.getRecStatus()!=1){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append("企业税号未备案#");
                return;
            }
            noCarWayBill.setCompanyName(customerRec.getCompanyName());
            noCarWayBill.setCustomerName(customerName);
            noCarWayBill.setBatchNum(batchNumber);
            //1.查询是否有车辆备案
            CustomerCarRec customerCarRec = customerCarRecMapper.selectByCarNum(noCarWayBill.getPlateColor());

            //2.无车车辆备案时进行车辆备案
            if(customerCarRec== null || customerCarRec.getRecStatus()!=1){
                List<CustomerCarRec> customerCarRecs = new ArrayList<>();
                customerCarRec = new CustomerCarRec();
                customerCarRec.setCompanyName(noCarWayBill.getCompanyName());
                customerCarRec.setCarNum(noCarWayBill.getPlateNum());
                customerCarRec.setCarColor(noCarWayBill.getPlateColor());
                customerCarRec.setCustomerName(customerName);
                customerCarRec.setBusinessType("2");
                customerCarRecs.add(customerCarRec);
                RespR respR = noCarService.customerCarRec(customerCarRecs);
                if(respR.getCode() ==1){
                    stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
                    return;
                }
            }

            //3.kais指令上传
            NoCarWayBill noCarWayBillClo = null;
            try{
                noCarWayBillClo = noCarWayBill.clone();
            }catch (Exception e){
               e.printStackTrace();
                noCarWayBillClo = noCarWayBill;
            }

            RespR respR = noCarService.noCarHisWaybillStart(noCarWayBill);
            if (respR.getCode() == 1){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
            }else{
                //3.kais指令上传
                respR = noCarService.noCarHisWaybillEnd(noCarWayBillClo);
                if(respR.getCode() == 1){
                    stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
                }else{
                    //取发票
                    noCarService.getInvoiceByWayBillNumReal(noCarWayBill,true);
                }
            }


        });
        if(!StringUtils.isEmpty(stringBuffer.toString())){
            return new RespR(false,stringBuffer.toString());
        }
        return new RespR(Boolean.TRUE);
    }

    @Override
    public RespR batchBillWayEnd(List<NoCarWayBill> noCarWayBills, String customerName) {
        StringBuffer stringBuffer = new StringBuffer();
        //保存批次号信息
        String batchNumber = customerOperService.saveCustomerOper(customerName,2);
        noCarWayBills.parallelStream().forEach(noCarWayBill -> {
            noCarWayBill.setBatchNumEnd(batchNumber);
            RespR respR = noCarService.noCarWaybillEnd(noCarWayBill);
            if (respR.getCode() == 1){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
            }
        });
        if(!StringUtils.isEmpty(stringBuffer.toString())){
            return new RespR(false,stringBuffer.toString());
        }
        return new RespR(Boolean.TRUE);
    }
}
